/*************************************
* A program to convert 60 x 50 pixel *
* Bmp files into ZZT files.  Assumes *
* that the bottom right pixel is     *
* unimportant, and places player in  *
* that position.                     *
*************************************/

#include <stdio.h>

FILE *inputf, *outputf, *zzttilesf, *startf, *endf;
unsigned char  bmpgrid[60][50][3];
unsigned char temp_inputc[3], temp_outputc;
int x, y, n, m, zztgrid[60][25][3], zzttiles[256][3], temp[4], temp_zztgrid[60][25];

int halftiles[2*15*8][6];
/*2=way up  15=forecolours  8=backcolours  6=RGB+RGB*/
int no_halftiles;
int orientation[255];
int position[255][2]; //x then y coordinates

int closest_tile;
long int diff, temp_diff;

long bestwholediff, improvement, top150[150];
long limit_diff;

int flag1;

int main(int argc, char *argv[])
{
  
  if (argc != 3)
  {
    printf("Usage of Bmp to ZZT converter:\n\n   %s input_file_name output_file_name\n\n", argv[0]);
    exit(1);
  }
  
  inputf = fopen(argv[1], "r");
  outputf = fopen(argv[2], "wb");
  zzttilesf = fopen("zzttiles.txt", "r");
  startf = fopen("zztstar2.txt", "r");
  endf = fopen("zztend2.txt", "r");
  
  for(n=0; n<102 - 16*3; ++n)
  {
    temp_inputc[0] = getc(inputf);
  }
  
  for(y=0; y<50; ++y)
  {
    for(x=0; x<60; ++x)
    {
      for(n=0; n<3; ++n)
      {
        bmpgrid[x][y][n] = getc(inputf);
      }
    }
  }
  
  for(y=0; y<256; ++y)
  {
    for(x=0; x<3; ++x)
    {
      for(n=0; n<4; ++n)
      {
        temp[n] = getc(zzttilesf) - 48;
      }
      zzttiles[y][x] = 100*temp[0] + 10*temp[1] + temp[2];
    }
  }
  
/*Initialise all temp grid with black on black normal*/
  
  for(y=0; y<25; ++y)
  {
    for(x=0; x<60; ++x)
    {
      temp_zztgrid[x][y] = 120;
    }
  }

/*Fill the halftiles[] reference array*/

  for(x=0; x<15; ++x)
  {
    for(y=0; y<8; ++y)
    {
      switch(y) //Backcolour
      {
        case 0:
          halftiles[x*8+y][0] = 0;
          halftiles[x*8+y][1] = 0;
          halftiles[x*8+y][2] = 0;
          halftiles[120+x*8+y][3] = 0;
          halftiles[120+x*8+y][4] = 0;
          halftiles[120+x*8+y][5] = 0;
          break;
        case 1:
          halftiles[x*8+y][0] = 0;
          halftiles[x*8+y][1] = 0;
          halftiles[x*8+y][2] = 168;
          halftiles[120+x*8+y][3] = 0;
          halftiles[120+x*8+y][4] = 0;
          halftiles[120+x*8+y][5] = 168;
          break;
        case 2:
          halftiles[x*8+y][0] = 0;
          halftiles[x*8+y][1] = 168;
          halftiles[x*8+y][2] = 0;
          halftiles[120+x*8+y][3] = 0;
          halftiles[120+x*8+y][4] = 168;
          halftiles[120+x*8+y][5] = 0;
          break;
        case 3:
          halftiles[x*8+y][0] = 0;
          halftiles[x*8+y][1] = 168;
          halftiles[x*8+y][2] = 168;
          halftiles[120+x*8+y][3] = 0;
          halftiles[120+x*8+y][4] = 168;
          halftiles[120+x*8+y][5] = 168;
          break;
        case 4:
          halftiles[x*8+y][0] = 168;
          halftiles[x*8+y][1] = 0;
          halftiles[x*8+y][2] = 0;
          halftiles[120+x*8+y][3] = 168;
          halftiles[120+x*8+y][4] = 0;
          halftiles[120+x*8+y][5] = 0;
          break;
        case 5:
          halftiles[x*8+y][0] = 168;
          halftiles[x*8+y][1] = 0;
          halftiles[x*8+y][2] = 168;
          halftiles[120+x*8+y][3] = 168;
          halftiles[120+x*8+y][4] = 0;
          halftiles[120+x*8+y][5] = 168;
          break;
        case 6:
          halftiles[x*8+y][0] = 168;
          halftiles[x*8+y][1] = 84;
          halftiles[x*8+y][2] = 0;
          halftiles[120+x*8+y][3] = 168;
          halftiles[120+x*8+y][4] = 84;
          halftiles[120+x*8+y][5] = 0;
          break;
        case 7:
          halftiles[x*8+y][0] = 168;
          halftiles[x*8+y][1] = 168;
          halftiles[x*8+y][2] = 168;
          halftiles[120+x*8+y][3] = 168;
          halftiles[120+x*8+y][4] = 168;
          halftiles[120+x*8+y][5] = 168;
          break;
      }
      switch(x) //Forecolour
      {
        case 0:
          halftiles[120+x*8+y][0] = 0;
          halftiles[120+x*8+y][1] = 0;
          halftiles[120+x*8+y][2] = 168;
          halftiles[x*8+y][3] = 0;
          halftiles[x*8+y][4] = 0;
          halftiles[x*8+y][5] = 168;
          break;
        case 1:
          halftiles[120+x*8+y][0] = 0;
          halftiles[120+x*8+y][1] = 168;
          halftiles[120+x*8+y][2] = 0;
          halftiles[x*8+y][3] = 0;
          halftiles[x*8+y][4] = 168;
          halftiles[x*8+y][5] = 0;
          break;
        case 2:
          halftiles[120+x*8+y][0] = 0;
          halftiles[120+x*8+y][1] = 168;
          halftiles[120+x*8+y][2] = 168;
          halftiles[x*8+y][3] = 0;
          halftiles[x*8+y][4] = 168;
          halftiles[x*8+y][5] = 168;
          break;
        case 3:
          halftiles[120+x*8+y][0] = 168;
          halftiles[120+x*8+y][1] = 0;
          halftiles[120+x*8+y][2] = 0;
          halftiles[x*8+y][3] = 168;
          halftiles[x*8+y][4] = 0;
          halftiles[x*8+y][5] = 0;
          break;
        case 4:
          halftiles[120+x*8+y][0] = 168;
          halftiles[120+x*8+y][1] = 0;
          halftiles[120+x*8+y][2] = 168;
          halftiles[x*8+y][3] = 168;
          halftiles[x*8+y][4] = 0;
          halftiles[x*8+y][5] = 168;
          break;
        case 5:
          halftiles[120+x*8+y][0] = 168;
          halftiles[120+x*8+y][1] = 84;
          halftiles[120+x*8+y][2] = 0;
          halftiles[x*8+y][3] = 168;
          halftiles[x*8+y][4] = 84;
          halftiles[x*8+y][5] = 0;
          break;
        case 6:
          halftiles[120+x*8+y][0] = 168;
          halftiles[120+x*8+y][1] = 168;
          halftiles[120+x*8+y][2] = 168;
          halftiles[x*8+y][3] = 168;
          halftiles[x*8+y][4] = 168;
          halftiles[x*8+y][5] = 168;
          break;
        case 7:
          halftiles[120+x*8+y][0] = 84;
          halftiles[120+x*8+y][1] = 84;
          halftiles[120+x*8+y][2] = 84;
          halftiles[x*8+y][3] = 84;
          halftiles[x*8+y][4] = 84;
          halftiles[x*8+y][5] = 84;
          break;
        case 8:
          halftiles[120+x*8+y][0] = 84;
          halftiles[120+x*8+y][1] = 84;
          halftiles[120+x*8+y][2] = 252;
          halftiles[x*8+y][3] = 84;
          halftiles[x*8+y][4] = 84;
          halftiles[x*8+y][5] = 252;
          break;
        case 9:
          halftiles[120+x*8+y][0] = 84;
          halftiles[120+x*8+y][1] = 252;
          halftiles[120+x*8+y][2] = 84;
          halftiles[x*8+y][3] = 84;
          halftiles[x*8+y][4] = 252;
          halftiles[x*8+y][5] = 84;
          break;
        case 10:
          halftiles[120+x*8+y][0] = 84;
          halftiles[120+x*8+y][1] = 252;
          halftiles[120+x*8+y][2] = 252;
          halftiles[x*8+y][3] = 84;
          halftiles[x*8+y][4] = 252;
          halftiles[x*8+y][5] = 252;
          break;
        case 11:
          halftiles[120+x*8+y][0] = 252;
          halftiles[120+x*8+y][1] = 84;
          halftiles[120+x*8+y][2] = 84;
          halftiles[x*8+y][3] = 252;
          halftiles[x*8+y][4] = 84;
          halftiles[x*8+y][5] = 84;
          break;
        case 12:
          halftiles[120+x*8+y][0] = 252;
          halftiles[120+x*8+y][1] = 84;
          halftiles[120+x*8+y][2] = 252;
          halftiles[x*8+y][3] = 252;
          halftiles[x*8+y][4] = 84;
          halftiles[x*8+y][5] = 252;
          break;
        case 13:
          halftiles[120+x*8+y][0] = 252;
          halftiles[120+x*8+y][1] = 252;
          halftiles[120+x*8+y][2] = 84;
          halftiles[x*8+y][3] = 252;
          halftiles[x*8+y][4] = 252;
          halftiles[x*8+y][5] = 84;
          break;
        case 14:
          halftiles[120+x*8+y][0] = 252;
          halftiles[120+x*8+y][1] = 252;
          halftiles[120+x*8+y][2] = 252;
          halftiles[x*8+y][3] = 252;
          halftiles[x*8+y][4] = 252;
          halftiles[x*8+y][5] = 252;
          break;
      }
    }
  }
  
          
  
  
/*Fill temp grid with real colours*/
  
  for(y=0; y<25; ++y)
  {
    for(x=0; x<60; ++x)
    {
      diff=393216;
      for(n=0; n<256; ++n)
      {
        temp_diff=0;
        temp_diff+=(bmpgrid[x][2*y][0] - zzttiles[n][2]) * (bmpgrid[x][2*y][0] - zzttiles[n][2]);
        temp_diff+=(bmpgrid[x][2*y][1] - zzttiles[n][1]) * (bmpgrid[x][2*y][1] - zzttiles[n][1]);
        temp_diff+=(bmpgrid[x][2*y][2] - zzttiles[n][0]) * (bmpgrid[x][2*y][2] - zzttiles[n][0]);
        temp_diff+=(bmpgrid[x][2*y+1][0] - zzttiles[n][2]) * (bmpgrid[x][2*y+1][0] - zzttiles[n][2]);
        temp_diff+=(bmpgrid[x][2*y+1][1] - zzttiles[n][1]) * (bmpgrid[x][2*y+1][1] - zzttiles[n][1]);
        temp_diff+=(bmpgrid[x][2*y+1][2] - zzttiles[n][0]) * (bmpgrid[x][2*y+1][2] - zzttiles[n][0]);
        if (temp_diff < diff)
        {
          diff=temp_diff;
          closest_tile = n;
        }
      }
      bestwholediff = diff;
      for(n=0; n<2*15*8; ++n)
      {
        temp_diff=3600;
        temp_diff+=(bmpgrid[x][2*y][0] - halftiles[n][2]) * (bmpgrid[x][2*y][0] - halftiles[n][2]);
        temp_diff+=(bmpgrid[x][2*y][1] - halftiles[n][1]) * (bmpgrid[x][2*y][1] - halftiles[n][1]);
        temp_diff+=(bmpgrid[x][2*y][2] - halftiles[n][0]) * (bmpgrid[x][2*y][2] - halftiles[n][0]);
        temp_diff+=(bmpgrid[x][2*y+1][0] - halftiles[n][5]) * (bmpgrid[x][2*y+1][0] - halftiles[n][5]);
        temp_diff+=(bmpgrid[x][2*y+1][1] - halftiles[n][4]) * (bmpgrid[x][2*y+1][1] - halftiles[n][4]);
        temp_diff+=(bmpgrid[x][2*y+1][2] - halftiles[n][3]) * (bmpgrid[x][2*y+1][2] - halftiles[n][3]);
        if (temp_diff < diff)
        {
          diff = temp_diff;
          closest_tile = n+256;
        }
      }
      improvement = bestwholediff - diff;
      if(improvement > 0 && improvement > top150[149])
      {
        for(n=149; n>=0 && improvement>top150[n]; n--)
        {
        }
        for(m=149; m>n+1; m--)
        {
          top150[m]=top150[m-1];
        }
        top150[n+1] = improvement;

printf("%d ", top150[149]);

      }
      
    }
  }
  
  for(n=148; n>=0 && top150[n] == top150[149]; n--)
  {
  }
  limit_diff = top150[n];

printf("\n%d", limit_diff);
  
  for(y=0; y<25; ++y)
  {
    for(x=0; x<60; ++x)
    {
      diff=393216;
      for(n=0; n<256; ++n)
      {
        temp_diff=0;
        temp_diff+=(bmpgrid[x][2*y][0] - zzttiles[n][2]) * (bmpgrid[x][2*y][0] - zzttiles[n][2]);
        temp_diff+=(bmpgrid[x][2*y][1] - zzttiles[n][1]) * (bmpgrid[x][2*y][1] - zzttiles[n][1]);
        temp_diff+=(bmpgrid[x][2*y][2] - zzttiles[n][0]) * (bmpgrid[x][2*y][2] - zzttiles[n][0]);
        temp_diff+=(bmpgrid[x][2*y+1][0] - zzttiles[n][2]) * (bmpgrid[x][2*y+1][0] - zzttiles[n][2]);
        temp_diff+=(bmpgrid[x][2*y+1][1] - zzttiles[n][1]) * (bmpgrid[x][2*y+1][1] - zzttiles[n][1]);
        temp_diff+=(bmpgrid[x][2*y+1][2] - zzttiles[n][0]) * (bmpgrid[x][2*y+1][2] - zzttiles[n][0]);
        if (temp_diff < diff)
        {
          diff=temp_diff;
          closest_tile = n;
        }
      }
      bestwholediff = diff;
      for(n=0; n<2*15*8; ++n)
      {
        temp_diff=limit_diff+3600;
        temp_diff+=(bmpgrid[x][2*y][0] - halftiles[n][2]) * (bmpgrid[x][2*y][0] - halftiles[n][2]);
        temp_diff+=(bmpgrid[x][2*y][1] - halftiles[n][1]) * (bmpgrid[x][2*y][1] - halftiles[n][1]);
        temp_diff+=(bmpgrid[x][2*y][2] - halftiles[n][0]) * (bmpgrid[x][2*y][2] - halftiles[n][0]);
        temp_diff+=(bmpgrid[x][2*y+1][0] - halftiles[n][5]) * (bmpgrid[x][2*y+1][0] - halftiles[n][5]);
        temp_diff+=(bmpgrid[x][2*y+1][1] - halftiles[n][4]) * (bmpgrid[x][2*y+1][1] - halftiles[n][4]);
        temp_diff+=(bmpgrid[x][2*y+1][2] - halftiles[n][3]) * (bmpgrid[x][2*y+1][2] - halftiles[n][3]);
        if (temp_diff < diff)
        {
          diff = temp_diff;
          closest_tile = n+256;
        }
      }
      
      temp_zztgrid[x][24 - y] = closest_tile;
    }
  }
  
  
  for(y=0; y<25; ++y)
  {
    for(x=0; x<60; ++x)
    {
      
/*Number in a row*/
      
      zztgrid[x][y][0] = 1;

/*First have the whole tiles*/
  if(temp_zztgrid[x][y] < 256)
  {
      
/*Background*/
      
      switch(temp_zztgrid[x][y] % 8)
      {
        case 0:
          zztgrid[x][y][2] += 0*16; /*Black*/
          break;
        case 1:
          zztgrid[x][y][2] += 7*16; /*L grey*/
          break;
        case 2:
          zztgrid[x][y][2] += 1*16; /*D blue*/
          break;
        case 3:
          zztgrid[x][y][2] += 2*16; /*D green*/
          break;
        case 4:
          zztgrid[x][y][2] += 3*16; /*D cyan*/
          break;
        case 5:
          zztgrid[x][y][2] += 4*16; /*D red*/
          break;
        case 6:
          zztgrid[x][y][2] += 5*16; /*D purple*/
          break;
        case 7:
          zztgrid[x][y][2] += 6*16; /*D yellow*/
          break;
      }
  
/*Foreground and type of tile*/
  
      if (temp_zztgrid[x][y] < 248)
      {
        if (temp_zztgrid[x][y] <128)
          zztgrid[x][y][1] = 0x16; /*Hex*/
        else
          zztgrid[x][y][1] = 0x17; /*Hex*/
      
        switch(((temp_zztgrid[x][y] - temp_zztgrid[x][y] % 8) / 8) % 16)
        {
          case 0:
            zztgrid[x][y][2] += 15; /*White*/
            break;
          case 1:
            zztgrid[x][y][2] += 9; /*Blue*/
            break;
          case 2:
            zztgrid[x][y][2] += 10; /*Green*/
            break;
          case 3:
            zztgrid[x][y][2] += 11; /*Cyan*/
            break;
          case 4:
            zztgrid[x][y][2] += 12; /*Red*/
            break;
          case 5:
            zztgrid[x][y][2] += 13; /*Purple*/
            break;
          case 6:
            zztgrid[x][y][2] += 14; /*Yellow*/
            break;
          case 7:
            zztgrid[x][y][2] += 8; /*D grey*/
            break;
          case 8:
            zztgrid[x][y][2] += 7; /*L grey*/
            break;
          case 9:
            zztgrid[x][y][2] += 1; /*D blue*/
            break;
          case 10:
            zztgrid[x][y][2] += 2; /*D green*/
            break;
          case 11:
            zztgrid[x][y][2] += 3; /*D cyan*/
            break;
          case 12:
            zztgrid[x][y][2] += 4; /*D red*/
            break;
          case 13:
            zztgrid[x][y][2] += 5; /*D purple*/
            break;
          case 14:
            zztgrid[x][y][2] += 6; /*D yellow*/
            break;
          case 15:
            zztgrid[x][y][2] += 0; /*Black (Normal only)*/
            break; 
        }
      }
      if (temp_zztgrid[x][y] >= 248)
      {
        zztgrid[x][y][1] = 0x15; /*Hex*/
        
        switch(temp_zztgrid[x][y] - 248)
        {
          case 0:
            zztgrid[x][y][2] += 8; /*D grey*/
            break;
          case 1:
            zztgrid[x][y][2] += 15; /*White*/
            break;
          case 2:
            zztgrid[x][y][2] += 9; /*Blue*/
            break;
          case 3:
            zztgrid[x][y][2] += 10; /*Green*/
            break;
          case 4:
            zztgrid[x][y][2] += 11; /*Cyan*/
            break;
          case 5:
            zztgrid[x][y][2] += 12; /*Red*/
            break;
          case 6:
            zztgrid[x][y][2] += 13; /*Purple*/
            break;
          case 7:
            zztgrid[x][y][2] += 14; /*Yellow*/
            break;
          default:
            printf("There is an error with a solid colour");
            exit(1);
        }
      }
  
  }
/*If not between 0 and 255 then must be a halftile*/
  else
  {
      
/*Type of tile (object)*/
      zztgrid[x][y][1] = 0x24;
      
/*Colour*/
      switch(temp_zztgrid[x][y] % 8)
      {
        case 0:
          zztgrid[x][y][2] = 0*16; /*Black*/
          break;
        case 1:
          zztgrid[x][y][2] = 1*16; /*DBlue*/
          break;
        case 2:
          zztgrid[x][y][2] = 2*16; /*DGreen*/
          break;
        case 3:
          zztgrid[x][y][2] = 3*16; /*DCyan*/
          break;
        case 4:
          zztgrid[x][y][2] = 4*16; /*DRed*/
          break;
        case 5:
          zztgrid[x][y][2] = 5*16; /*DPurple*/
          break;
        case 6:
          zztgrid[x][y][2] = 6*16; /*DYellow*/
          break;
        case 7:
          zztgrid[x][y][2] = 7*16; /*LGrey*/
          break;
      }
      switch( (((temp_zztgrid[x][y] - temp_zztgrid[x][y]%8) - 256) / 8) % 15)
      {
        case 0:
          zztgrid[x][y][2] += 1; /*DBlue*/
          break;
        case 1:
          zztgrid[x][y][2] += 2; /*DGreen*/
          break;
        case 2:
          zztgrid[x][y][2] += 3; /*DCyan*/
          break;
        case 3:
          zztgrid[x][y][2] += 4; /*DRed*/
          break;
        case 4:
          zztgrid[x][y][2] += 5; /*DPurple*/
          break;
        case 5:
          zztgrid[x][y][2] += 6; /*DYellow*/
          break;
        case 6:
          zztgrid[x][y][2] += 7; /*LGrey*/
          break;
        case 7:
          zztgrid[x][y][2] += 8; /*DGrey*/
          break;
        case 8:
          zztgrid[x][y][2] += 9; /*Blue*/
          break;
        case 9:
          zztgrid[x][y][2] += 10; /*Green*/
          break;
        case 10:
          zztgrid[x][y][2] += 11; /*Cyan*/
          break;
        case 11:
          zztgrid[x][y][2] += 12; /*Red*/
          break;
        case 12:
          zztgrid[x][y][2] += 13; /*Purple*/
          break;
        case 13:
          zztgrid[x][y][2] += 14; /*Yellow*/
          break;
        case 14:
          zztgrid[x][y][2] += 15; /*White*/
          break;
      }
    
/*End the halftile if statement*/
  }
      
      
    }
  }

/*Now put player in the bottom right corner*/

  zztgrid[59][24][0] = 0x1;
  zztgrid[59][24][1] = 0x4;
  zztgrid[59][24][2] = 0x1F;
  

/*Hopefully should now have all the correct values in the zztgrid array*/
/*Also hopefully back at base level in the main*/

/*Put start into file*/

  for(n=0;n<565 /*(temp_outputc = getc(startf)) != EOF*/;++n)
  {
    temp_outputc = getc(startf);
    putc(temp_outputc, outputf);
  }

/*Put picture into file*/

  for(y=0; y<25; ++y)
  {
    for(x=0; x<60; ++x)
    {
      for(n=0; n<3; ++n)
      {
        putc(zztgrid[x][y][n], outputf);
      }
    }
  }

///*Put end into file*/
//
//  for(n=0;n<(710 - 121);++n)
//  {
//    temp_outputc = getc(endf);
//  }
//
//  for(n=0;n<121/*(temp_outputc = getc(endf)) != EOF*/;++n)
//  {
//    temp_outputc = getc(endf);
//    putc(temp_outputc, outputf);
//  }

  putc(0xff, outputf);
  for(n=0; n<65; n++)
  {
    putc(0x00, outputf);
  }
  putc(0xff, outputf);
  putc(0xff, outputf);
  for(n=0; n<18; n++)
  {
    putc(0x00, outputf);
  }
  
/*Count the number of objects used (half tiles)*/
  no_halftiles=0;
  for(x=0; x<60; x++)
  {
    for(y=0; y<25; y++)
    {
      if(zztgrid[x][y][1] == 0x24)
      {
        orientation[no_halftiles] = (temp_zztgrid[x][y] >= 256+120);
        position[no_halftiles][0] = x+1;
        position[no_halftiles][1] = y+1;
        no_halftiles++;
      }
    }
  }
  
  if(no_halftiles > 150)
  {
    printf("Too many half-tiles needed.  Please do something manually to sort this.\n");
    printf("Max half-tiles = 150\nHalf-tiles needed = %d\n", no_halftiles);
    exit(1);
  }  

  putc(no_halftiles, outputf);
  
  putc(0x00, outputf);
  putc(0x3c, outputf);
  putc(0x19, outputf);
  for(n=0; n<4; n++)
  {
    putc(0x00, outputf);
  }
  putc(0x01, outputf);
  for(n=0; n<26; n++)
  {
    putc(0x00, outputf);
  }
  
  for(x=2; x<no_halftiles+2; x++)
  {
    putc(position[x-2][0], outputf); //x coordinate
    putc(position[x-2][1], outputf); //y coordinate
    for(n=0; n<4; n++)
    {
      putc(0x00, outputf);
    }
    putc(0x03, outputf);
    putc(0x00, outputf);
    
/*Insert Orientation*/
    if(orientation[x-2] == 1)
    {
      putc(0xdc, outputf);
    }
    else
    {
      putc(0xdf, outputf);
    }
    
    putc(0x00, outputf);
    putc(0x00, outputf);
    for(n=0; n<4; n++)
    {
      putc(0xff, outputf);
    }
    putc(0x00, outputf);
    putc(0x0f, outputf);
    for(n=0; n<16; n++)
    {
      putc(0x00, outputf);
    }
  }
    
    




/*Close files*/

  close(inputf);
  close(outputf);
  close(zzttilesf);
  close(startf);
  close(endf);

}





